# Name:        CTrun v1.0
#
# Author:      JoeyT2007
#
# Description: Allows CT's to pick up the bomb and run away.
#
# Bugs:        1. CT's can't drop the bomb the first time, they need to drop it twice. After that it will work fine.
#
# Credits:     Creator         JoeyT2007
#
#              Idea            SuperDave
#
#              Thanks          R`SiN
#                              GODJonez
#                              Errant
#                              Einlanzers
#                              Sniperhmm
#                              Venjax

import es
from es import server_var
import playerlib
import gamethread
import vecmath
import random

ctrun_c4 = 0
ctrun_c4_location = 0
ctrun_c4_dropped = 0
ctrun_player = 0
targetid = 0
target = 0
ctrun_player_location = 0
ctrun_player_name = 0
ctrun_playerlist = 0
ctrun_distance = 0
ctrun_planted_c4 = 0
ctrun_immune = -1
ctrun_c4_count = 0
ctrun_c4_temp = 0
ctrun_c4_list = 0
ctrun_player_team = 0
ctrun_player_alive = es.ServerVar("ctrun_player_alive", 0)
ctrun_ver = es.ServerVar("ctrun_ver", "1.0", "Version of CTrun that you are using.")
ctrun_ver.makepublic()
x = 0

info = es.AddonInfo()
info.name = "CTrun"
info.version = "1.0"
info.author = "JoeyT2007"
info.url = "http://forums.mattie.info/cs/forums/viewtopic.php?p=162585"
info.description = "Allows CT's to pick up the bomb and run away."
info.basename = "ctrun"

def load():
    checkc4()

def unload():
    gamethread.cancelDelayed("checkc4loop")
    gamethread.cancelDelayed("playerhasc4")
    gamethread.cancelDelayed("undoimmunity")

def round_start(event_var):
    gamethread.cancelDelayed("checkc4loop")
    gamethread.cancelDelayed("playerhasc4")
    gamethread.cancelDelayed("undoimmunity")
    es.msg("#multi", "#green[CTrun]#lightgreen CT's #defaultcan pickup the bomb when dropped.")
    setimmunity()
    checkc4()

def round_end(event_var):
    es.server.cmd("est_team %i 3" % ctrun_player)

def checkc4():
    ctrun_c4_list = es.createentitylist('weapon_c4')
    ctrun_count = len(ctrun_c4_list)
    if ctrun_count == 1:
        ctrun_planted_c4 = es.getentityindex("planted_c4")
        if ctrun_planted_c4 == -1:
            global ctrun_c4
            ctrun_c4 = es.getentityindex("weapon_c4")
            if ctrun_c4 != -1:
                ctrun_c4_dropped = es.getindexprop(ctrun_c4, "CBaseEntity.m_hOwnerEntity")
                if ctrun_c4_dropped == -1:
                    ctrun_c4_location = es.getindexprop(ctrun_c4, "CBaseEntity.m_vecOrigin")
                    ctrun_playerlist = playerlib.getPlayerList('#all')
                    for targetid in ctrun_playerlist:
                        if (not int(targetid.attributes['isdead'])) and int(targetid.attributes['teamid'])==3:
                            if int(targetid) != ctrun_immune:
                                target = int(targetid)
                                ctrun_player_location = vecmath.vector((targetid.attributes['x'], targetid.attributes['y'], targetid.attributes['z']))
                                ctrun_distance = vecmath.distance(ctrun_c4_location, ctrun_player_location)
                                if ctrun_distance <= 100:
                                    pickupc4(target)
    gamethread.delayedname(0.2, "checkc4loop", checkc4)

def pickupc4(ctrun_player):
    es.server.cmd("est_team %i 2" % ctrun_player)
    es.give(ctrun_player, "weapon_c4")
    es.remove(ctrun_c4)
    global ctrun_c4
    ctrun_c4 = es.ServerVar("eventscripts_lastgive")
    es.server.cmd("es_delayed 0.1 est_team %i 3" % ctrun_player)
    gamethread.cancelDelayed("playerhasc4")
    gamethread.delayedname(3, "playerhasc4", playerhasc4(ctrun_player))

def bomb_beginplant(event_var):
    ctrun_player_team = 0
    ctrun_player_team = es.getplayerteam(event_var["userid"])
    if ctrun_player_team == 3:
        es.remove("weapon_c4")
        es.server.cmd("est_team %i 2" % int(event_var["userid"]))
        es.give(int(event_var["userid"]), "weapon_c4")
        global ctrun_c4
        ctrun_c4 = es.ServerVar("eventscripts_lastgive")
        es.server.cmd("es_delayed 0.1 est_team %i 3" % int(event_var["userid"]))

def playerhasc4(ctrun_player):
    ctrun_player_alive = es.ServerVar("ctrun_player_alive", 0)
    es.server.cmd("est_isalive ctrun_player_alive %i" % ctrun_player)
    if ctrun_player_alive == 1:
        ctrun_hasc4 = 0
        es.server.cmd("playerget ctrun_hasc4 %i" % ctrun_player)
        if ctrun_hasc4 == 1:
            gamethread.delayedname(0.1, "playerhasc4", playerhasc4(ctrun_player))
        else:
            global ctrun_immune
            ctrun_immune = ctrun_player
            gamethread.delayedname(2.5, "undoimmunity", setimmunity)

def setimmunity():
    global ctrun_immune
    ctrun_immune = -1